//
// Created by webpigeon on 29/12/22.
//

#include "labs/counting/lab2.hpp"

/**
 * Calculate the average value of a vector of ints.
 *
 * @param numbers the numbers to calculate
 * @return the average of the input values
 */
float calcAverage(std::vector<int> numbers) {
    int total = 0;
    unsigned int size = 0; //probably should be size_t

    while ( !numbers.empty() ) {
        total += numbers[0];
        numbers.erase( numbers.begin() );
        size++;
    }

    return total / (float)size;
}

/**
 * Calculate the average value of a vector of ints.
 *
 * This version avoids modifying the vector, so doesn't have the overheads associated with that. It's here as a
 * 'reasonable' approach to the problem. Assuming you can't calculate the sum as you go and avoid the need for
 * the vector all-together...
 *
 * @param numbers the numbers to calculate
 * @return the average of the input values
 */
float calcAverageFast(const std::vector<int>& numbers) {
    int total = 0;

    for( auto& number : numbers ) {
        total += number;
    }

    return total / (float)numbers.size();
}